c# 获取cad文档的路径_C#中读取cad文件中的属性

using System;

using System.IO;

using System.Collections.Generic;

using System.ComponentModel;

using System.Data;

using System.Drawing;

using System.Text;

using System.Windows.Forms;

using Autodesk.AutoCAD.ApplicationServices;

using Autodesk.AutoCAD.DatabaseServices;

Database db = new Database(false, true);

try

{

//把DWG文件读入到一个临时的内存数据库中

db.ReadDwgFile(fullFileName, System.IO.FileShare.ReadWrite, true, null);

//现在进入数据库并获得数据库的块表引用

BlockTable bt = (BlockTable)trans.GetObject(db.BlockTableId, OpenMode.ForRead, false, true);

//从块表的模型空间特性中获得块表记录,块表记录对象包含DWG文件数据库实体

BlockTableRecord btr = (BlockTableRecord)trans.GetObject(bt[BlockTableRecord.ModelSpace], OpenMode.ForRead, false, true);

foreach (ObjectId btrId in btr)

{

DBObject entBlock = (DBObject)trans.GetObject(btrId, OpenMode.ForRead, false, true);

if (entBlock.GetRXClass().DxfName.ToUpper() == “INSERT”)

{

BlockReference bRef = (BlockReference)entBlock;

if (bRef.AttributeCollection.Count != 0)

{

System.Collections.IEnumerator bRefEnum = bRef.AttributeCollection.GetEnumerator();

while (bRefEnum.MoveNext())

{

ObjectId aId = (ObjectId)bRefEnum.Current;//这一句极其关键

AttributeReference aRef = (AttributeReference)trans.GetObject(aId, OpenMode.ForRead, false, true);

aRef.TextString;//此语句即获得属性单行文本,请自行在此语句前添加 属性单行文本 赋于的变量

}

}

}

}

trans.Commit(); //提交事务处理

btr.Dispose();

bt.Dispose();

}

catch (System.Exception ex)

{

MessageBox.Show(“\n出错啦: ” + ex.Message);

}

finally

{

db.Dispose();

}

  • 0
    点赞
  • 4
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值